# SourcePath: glibc-2.22/20170112
Summary: Embedded Glibc.
Name: sony-target-dev-glibc-libpthread_ptt
%define pkgname %{sony_tool_triplet}-%{sony_target_dialect}-dev-glibc-libpthread_ptt
Version: 2.22
Release: 12000001
License: LGPL2.1 / Other
Distribution: %{sony_distribution}
Vendor: %{sony_vendor}
Packager: %{sony_packager}
Group: %{sony_group}
URL: http://www.glibc.org/home
Source0: glibc-%{version}.tar.bz2

## LOT script Files
Source10: sony-devel-libopt-build-libc
Source11: sony-devel-libopt-build-libcrypt
Source12: sony-devel-libopt-build-libdl
Source13: sony-devel-libopt-build-libm
Source14: sony-devel-libopt-build-libpthread
Source15: sony-devel-libopt-build-librt

Patch001: 0004-Backport-https-sourceware.org-ml-libc-ports-2007-12-.patch
Patch002: 0005-fsl-e500-e5500-e6500-603e-fsqrt-implementation.patch
Patch003: 0007-ppc-sqrt-Fix-undefined-reference-to-__sqrt_finite.patch
Patch004: 0008-__ieee754_sqrt-f-are-now-inline-functions-and-call-o.patch
Patch005: 0009-Quote-from-bug-1443-which-explains-what-the-patch-do.patch
Patch006: 0010-eglibc-run-libm-err-tab.pl-with-specific-dirs-in-S.patch
Patch007: 0011-__ieee754_sqrt-f-are-now-inline-functions-and-call-o.patch
Patch008: 0012-Make-ld-version-output-matching-grok-gold-s-output.patch
Patch009: 0013-sysdeps-gnu-configure.ac-handle-correctly-libc_cv_ro.patch
Patch010: 0014-Add-unused-attribute.patch
Patch011: 0015-When-disabling-SSE-also-make-sure-that-fpmath-is-not.patch
Patch012: 0016-yes-within-the-path-sets-wrong-config-variables.patch
Patch013: 0017-timezone-re-written-tzselect-as-posix-sh.patch
Patch014: 0018-eglibc-Cross-building-and-testing-instructions.patch
Patch015: 0019-eglibc-Bring-Eglibc-option-group-infrastructure-to-g.patch
Patch016: 0020-eglibc-Help-bootstrap-cross-toolchain.patch
Patch017: 0024-eglibc-Forward-port-eglibc-options-groups-support.patch
Patch018: 0026-eglibc-dl_debug_mask-is-controlled-by-__OPTION_EGLIB.patch
Patch019: 0027-eglibc-use-option-groups-Conditionally-exclude-c-tes.patch
Patch020: nscd-no-bash.patch
Patch021: strcoll-Remove-incorrect-STRDIFF-based-optimization-.patch
Patch022: 0028-Clear-ELF_RTYPE_CLASS_EXTERN_PROTECTED_DATA-for-prel.patch
Patch023: CVE-2015-8777.patch
Patch024: CVE-2015-8779.patch
Patch025: CVE-2015-9761_1.patch
Patch026: CVE-2015-9761_2.patch
Patch027: CVE-2015-8776.patch
Patch028: CVE-2015-7547.patch
Patch029: CVE-2015-8778.patch
Patch030: CVE-2016-3706.patch
Patch031: CVE-2016-4429.patch
#Patch100: 0001-Add-ARM-specific-static-stubs.c.patch

# Add PTT support.
Patch200: glibc-2.22-ptt.patch
Patch201: glibc-2.22-ptt-arm.patch
Patch202: glibc-2.22-ptt-fix-sem-post-out.patch
Patch203: glibc-2.22-ptt-sigqueue.patch
Patch204: glibc-2.22-ptt-build-fixes.patch

BuildRoot: %{_tmppath}/%{name}-root
Prefix: %{sony_target_dir}

BuildRequires: %{sony_tool_triplet}-cross-libopt-for-dev

%description
The standard libraries that are used by nearly all programs on the system.
This package includes shared versions of the standard C library and the
standard math library, as well as many others. Timezone data is also
included.

%package -n %{pkgname}
Summary: The GNU C Library.
Group: %{sony_group}
AutoReqProv: no


%description -n %{pkgname}
The standard libraries that are used by nearly all programs on the system.
This package includes shared versions of the standard C library and the
standard math library, as well as many others. Timezone data is also
included.

%prep
%setup -q -n glibc-%{version}

# Apply patches
%patch001 -p1
%patch002 -p1
%patch003 -p1
%patch004 -p1
%patch005 -p1
%patch006 -p1
%patch007 -p1
%patch008 -p1
%patch009 -p1
%patch010 -p1
%patch011 -p1
%patch012 -p1
%patch013 -p1
%patch014 -p1
%patch015 -p1
%patch016 -p1
%patch017 -p1
%patch018 -p1
%patch019 -p1
%patch020 -p1
%patch021 -p1
%patch022 -p1
%patch023 -p1
%patch024 -p1
%patch025 -p1
%patch026 -p1
%patch027 -p1
%patch028 -p1
%patch029 -p1
%patch030 -p1
%patch031 -p1
#%patch100 -p1

%patch200 -p1
%if %{sony_target_cpu} == "arm"
%patch201 -p1
%endif
%patch202 -p1
%patch203 -p1
%patch204 -p1

#
# NOTE: Build with nptl, with TLS
#
%build
%sony_target_dev_setup

%define _header_dir %{sony_target_dir}%{sony_target_dev_include_dir}

export CFLAGS="-O2 -g"
export LD_LIBRARY_PATH="%{sony_target_dir}%{sony_target_dev_lib_dir}"

# autoconf cause "checking for grep that handles long lines and -e"
# failure, config.log msg: error: no acceptable grep could be found
%if "%{sony_target_cpu}" == "ppc"
   export libc_cv_ppc_machine=yes \
	  libc_cv_ppc_rel16=no \
%endif
# to build nptl
export libc_cv_forced_unwind=yes
export libc_cv_c_cleanup=yes
export libc_cv_gnu99_inline=yes

# build libpthread library for PTT.
export BUILD_CC="gcc"
%sony_target_dev_configure \
	--disable-sanity-checks \
	--enable-kernel=3.4.0 \
	--enable-profile \
	--without-cvs \
%if "%{sony_target_fpu}" == "no"
	--without-fp \
%endif
	--with-tls \
	--with-__thread \
	--without-gd \
        --with-ptt \
	--with-headers=%{_header_dir} &&
cat <<EOF > configparms &&
slibdir=%{sony_target_dev_dir}/lib
sysconfdir=%{sony_target_dev_dir}/etc
EOF
make OBJDUMP_FOR_HOST=%{sony_target_toolprefix}objdump all

mv nptl/{libpthread.so,libpthread_ptt-%{version}.so}

%install
%sony_target_dev_setup

rm -rf %{buildroot}
%define _libdir %{buildroot}%{sony_target_dir}%{sony_target_devtool_lib_dir}

mkdir -p %{_libdir}
cd %{sony_objdir}
install -m 755 nptl/libpthread_ptt-%{version}.so  %{_libdir}
(cd %{_libdir} ; ln -s libpthread_ptt-%{version}.so libpthread_ptt.so.0)

%clean
rm -rf %{buildroot}

%files -n %{pkgname}
%defattr(-,root,root)

%{sony_target_dir}%{sony_target_devtool_lib_dir}/libpthread_ptt.so.0
%{sony_target_dir}%{sony_target_devtool_lib_dir}/libpthread_ptt-%{version}.so

%changelog
* Fri Jan 27 2017 Sony Corporation
- Added ptt support for glibc-2.22

* Thu May 05 2016 Sony Corporation
- Added armhf support in LOT build script

* Tue Feb 23 2016 Sony Corporation
- Added CVE-2015-7547 and depended patches
- Added CVE-2013-7423, CVE-2014-8121, CVE-2014-9761, CVE-2015-1472, CVE-2015-1473, CVE-2015-1781,
  CVE-2015-8776, CVE-2015-8778, CVE-2015-8779

* Mon Jul 06 2015 Sony Corporation
- Refreshed CVE patches CVE-2012-4412, CVE-2012-4424, CVE-2013-2207, CVE-2014-0475 and CVE-2014-6040

* Mon Feb 09 2015 Sony Corporation
- Added CVE-2014-7817,CVE-2014-9402 and CVE-2015-0235 fix patches

* Mon Sep 29 2014 Sony Corporation
- Added CVE-2013-0242,CVE-2013-1914,CVE-2013-4332,CVE-2012-4412,
  CVE-2013-4458,CVE-2013-2207,CVE-2014-0475,CVE-2014-5119,
  CVE-2014-6040 and CVE-2014-4043 fix patches

* Tue Oct 08 2013 Sony Corporation
- Added ld.so memory leak fix patch

* Mon Apr 15 2013 Sony Corporation
- Initial Build.
